#include <fstream>
#include<iostream>
# define mod 1114111LL
using namespace std;
long long power (long long n, long long k)
{
    long long x;
    if (k==0)
        return 1;
    else
        {
            x=power(n,k/2);
            if (k%2)
                return ( n*((x*x) %mod))%mod ;
            else
                return (x*x) %mod;
        }
}
long long comb(long long n, long long k)
{   long long h,sus=1,jos=1,nrsus=0,nrjos=0;
    for (long long i=n;i>n-k;--i)
    {
        h=i;
        while (!(h%mod))
        {
            ++nrsus;
            h/=mod;
        }
        sus=(sus*h) % mod;
    }
    for (long long i=1;i<=k;++i)
    {
        h=i;
        while (!(h%mod))
        {
            ++nrjos;
            h/=mod;
        }
        jos=(jos*h) % mod;
    }
    if (nrsus>nrjos)
        return 0;
    else
        return (sus*power(jos,mod-2))%mod;
}
int main()
{   long long n,x,y,v,t,z;
    ifstream fin("maxmaxmax.in");
    ofstream fout("maxmaxmax.out");
    fin>>n>>x>>y;
    v=y-x+1;    // v numarul de elemente distincte din interval
    if (n%3==0)
    {
        if (n/3<=y-x+1)
        {
            t=n/3-1;   // t numarul de trepte in sirul a
            fout<<comb(n+v-t-1,n)<<"\n";
        }
        else
        {
            fout<<comb(v,n%v)<<"\n";
        }
    }
    if (n%3==2)
    {
        if ((n+1)/3<=y-x)
        {
            t=(n-2)/3;
            fout<<(((t+1) % mod)*(comb(n+v-t-1,n)))%mod<<"\n";
        }
        else
        {
            fout<<comb(v,n%v)<<"\n";
        }
    }
    if (n%3==1)
    {
        if ((n-1)/3<=y-x)
        {
            t=(n-1)/3;  //   t     numarul de trepte pentru 2,2,3,3, ....
                        // (t+1) e numarul de trepte pentru 4,3,3,...
            if (t%2)
                z=((t+1)/2*t) % mod;
            else
                z=(t/2*(t+1)) % mod;
            if (v-t>n)
                fout<<(((t% mod)*comb(n+v-t,n))%mod+(z*comb(n+v-t-1,n))%mod)%mod;
            else
                fout<<(((t%mod)*comb(n+v-t,v-t))%mod+(z*comb(n+v-t-1,v-t-1))%mod)%mod;
        }//     cazul 4,3,...      cazul 2,2,3....
        else
        {
            fout<<comb(v,n%v);
        }
    }
    fout.close();
    return 0;
}
